#include <GL/glut.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <math.h>
#include <stdlib.h>
#include <iostream>
#include <fstream>
#include <stdio.h>
#include <string.h>
#include <dirent.h>
#include <sys/stat.h>
#include <time.h>
#include <unistd.h>
#include <glib.h>

#include <files.hpp>

#define BUFSIZE 256
#define max_size 5
#define file_div 1000

using namespace std;

float ratio, cr;
float angle, deltaAngle, rota, x, y, z, lx, ly, lz, oldMouseH=0; //these are used for moving around
int swV2, tsw, swV1; //these are all used to switch levels
int view, clevel, numLevels, goDown, goUp, goZ, showNames, showAllNames, fSelectCT, displayInfo = 0, rotateCube, fogOnOff = 1, fOrB = 0;

double fps,frame,mouseF,yConv=0,xConv=0;
int ftime,timebase,mouseTime,mouseTB,deltaMove,oldMouseX,oldMouseY;
int specialKey;

GLuint selectBuf[BUFSIZE], *mptr = 0;
int fullscreen = 0, xmouse, ymouse, totalFiles = 0, mouseMove = 0;
const int wx = 1024, wy = 768; //window x,y size
const int wxp = 100, wyp = 100; //window x,y position
const int dirColor = 1;
const int fileColor = 0;
const int mouse_delay = 1; //mouse delay in seconds
int fMode = 0; //0 = nothing, 1 = copy, 2 = move, 3 = delete
int mouseStop = 0;
char mouseOver[256], fSelect[256];
int mainWindow;	//main glut window


fileData files[256][256];
levelData levels[1024];
selectList fileNames[1024];

void moveMeFlat(float i) {
	x += i*(lx)*0.1;
	z += i*(lz)*0.1;
	glLoadIdentity();
	gluLookAt(x, y, z,x + lx,y + ly,z + lz,0.0f,1.0f,0.0f);
}

void orientMe(float ang) {
	lx = sin(ang);
	lz = -cos(ang);
	glLoadIdentity();
	gluLookAt(x, y, z,x + lx,y + ly,z + lz,0.0f,1.0f,0.0f);
}

void setMap() {
	char* pwd;
	char* pch;
	char cwd[256],orig[256];
	int level, levelSize, numFiles, fColor;
	double box_size;
	DIR *dirp;
    struct dirent *dp;
	pwd = getcwd(cwd,256);
	strcpy(orig,cwd);
	numLevels = 0;
	y = 0;
	// the following if statement/for loop just sets the amount of levels
	if (strlen(cwd) > 1) {
	    pch = strpbrk (cwd, G_DIR_SEPARATOR_S);
	    while (pch != NULL)
	    {
	        numLevels++;
	        pch = strpbrk (pch+1,G_DIR_SEPARATOR_S);
	    }

	} else { numLevels = 0; }
	// <-- and now the number of levels is stored in numLevels
	level = numLevels;
    // the next function sets all the file information into the array
   	totalFiles = 0;
	do
	{
		levelSize = 0;
		numFiles = 0;
	    if ((dirp = opendir(".")) == NULL) { return; }
	    do {
	        if ((dp = readdir(dirp)) != NULL) {
	        	if (strcmp(dp->d_name,"."))
	        	{
	                if (fileSize(dp->d_name)/file_div < max_size)
	                {
	                    box_size = fileSize(dp->d_name)/file_div;
	                    if (fileSize(dp->d_name)/file_div > levelSize) { levelSize = fileSize(dp->d_name)/file_div; }
	                } else { levelSize = max_size; box_size = max_size; }
	                if (!isDir(dp->d_name))
	                {
                        fColor = 0;
	                } else { fColor = 1; }
                	if (!strcmp(dp->d_name,".."))
                    {
                        fColor = 2;
                        box_size = .5;
                    }
	                files[level][numFiles].set(dp->d_name,fileSize(dp->d_name),getMMode(dp->d_name),getMDate(dp->d_name),fColor,box_size);
	                fileNames[totalFiles].set(level,numFiles);
	                numFiles++;
	                totalFiles++;
	            }
	        }
	    } while (dp != NULL && numFiles < (BUFSIZE - 1));
	    closedir (dirp);
	    levels[level].set(getcwd(cwd,256),numFiles,levelSize);
	    y+=levelSize+1;
	    chdir("..");
	    level--;
	} while (level > -1);
	// <-- keep going until you are at the root directory
	chdir(orig); // go back to the original directory
	return;
}

void processMouse(int button, int state, int xm, int ym) {
	char wtg[256];
	float oy;
	specialKey = glutGetModifiers();
	if (state == GLUT_DOWN) {
	    switch (button)
	    {
			case 3:
				if (!mouseMove)
				{
					goUp = 1;
					orientMe(angle);
				} else { oldMouseH++; }
				break;
			case 4:
				if (!mouseMove)
				{
					goDown = 1;
					orientMe(angle);
				} else { oldMouseH--; }
				break;
			case 0:
	            if (!mouseStop)
	            {
	            	if (mptr != 0)
	            	{
	                    strcpy(wtg,levels[fileNames[*mptr].level].name);
	                    if (strcmp (wtg, G_DIR_SEPARATOR_S)) { strcat (wtg, G_DIR_SEPARATOR_S); }
	                    strcat(wtg,files[fileNames[*mptr].level][fileNames[*mptr].filenum].name);
	                    if (isDir(wtg))
	                    {
	                    	oy = y;
	                        chdir(wtg);
	                        setMap();
	                        if (!strcmp(files[fileNames[*mptr].level][fileNames[*mptr].filenum].name,"..")) { if (clevel > numLevels) { goDown = 1; } } else { goUp = 1; }
	                        y = oy;
	                        orientMe(angle);
	                    } else {
	                        cout << "execute " << wtg << endl;
	                    }
	                }
	                mouseStop = 1;
	            }
	            break;
	        case 1:
	            if (!mouseStop)
	            {
                    if (mptr != 0)
                    {
                    	if (fMode < 3)
                    	{
	                        strcpy(wtg,levels[fileNames[*mptr].level].name);
                                if (strcmp (wtg, G_DIR_SEPARATOR_S))
                                    strcat (wtg, G_DIR_SEPARATOR_S);
	                        strcat(wtg,files[fileNames[*mptr].level][fileNames[*mptr].filenum].name);
	                        if (!fSelectCT)
	                        {
	                            if (isDir(wtg))
	                            {
	                                strcpy(fSelect,wtg);
	                                fSelectCT = 1;
	                            } else {
	                                strcpy(fSelect,"Must be Directory");
	                            }
	                        } else {
	                                char sysCom[256];
	                                switch (fMode)
	                                {
	                                    case 1:
	                                        strcpy(sysCom,"cp -R ");
	                                        break;
	                                    case 2:
	                                        strcpy(sysCom,"mv ");
	                                        break;
	                                }
	                                strcat(sysCom,wtg);
	                                strcat(sysCom," ");
	                                strcat(sysCom,fSelect);
	                                cout << sysCom << endl;
	                        }
	                    } else {
                            strcpy(wtg,levels[fileNames[*mptr].level].name);
                                if (strcmp (wtg, G_DIR_SEPARATOR_S))
                                    strcat (wtg, G_DIR_SEPARATOR_S);
	                        strcat(wtg,files[fileNames[*mptr].level][fileNames[*mptr].filenum].name);
	                        if (!fSelectCT)
	                        {
                                strcpy(fSelect,wtg);
                                fSelectCT = 1;
	                        } else if (fSelectCT == 1) {
								fSelectCT++;
	                        } else if (fSelectCT == 2) {
	                                char sysCom[256];
                                    strcpy(sysCom,"rm -r"); // This could also be abstracted
	                                strcat(sysCom,wtg);
	                                cout << sysCom << endl;
	                        }
	                    }
                    } else { memset(fSelect,' ',strlen(fSelect)); fSelectCT=0; fMode = 0; }
	                mouseStop = 1;
	            }
	            break;
	    }
	}
}

void processMouseActiveMotion(int x, int y) {
// for future use
}

void processMousePassiveMotion(int x, int y) {
	xmouse = x;
	ymouse = y;
	if (mouseMove)
	{
		yConv = ((double)y/(double)oldMouseY-1);
		xConv = ((double)x/(double)oldMouseX-1);
	} else {
		oldMouseX = x;
		oldMouseY = y;
	}
}

void processMouseEntry(int state) {
//for future use
}

void renderString2(float x,float y,char *string) {
	char *c;
	glRasterPos2f(x, y);
	for (c=string; *c != '\0'; c++) {
		glutBitmapCharacter(GLUT_BITMAP_HELVETICA_18, *c);
	}
}

void renderString3(float x,float y,float z,char *string) {
  char *c;
  glRasterPos3f(x, y, z);
  for (c=string; *c != '\0'; c++) {
    glutBitmapCharacter(GLUT_BITMAP_HELVETICA_18, *c);
  }
}

void changeSize(int w, int h) {

	if (!h) { h = 1; }
	if (!w) { w = 1; }
	ratio = 1.0f * w / h;
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glViewport(0, 0, w, h);
	gluPerspective(45,ratio,1,1000);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	gluLookAt(x, y, z,x + lx,y + ly,z + lz,0.0f,1.0f,0.0f);
}

void initScene() {
	glEnable(GL_DEPTH_TEST);
	glShadeModel(GL_SMOOTH);
	GLfloat fogColor[4]= {0.0f, 0.0f, 0.0f, 1.0f};

	glClearColor(0.0f,0.0f,0.0f,1.0f);
	glFogi(GL_FOG_MODE, GL_LINEAR);
	glFogfv(GL_FOG_COLOR, fogColor);
	glFogf(GL_FOG_DENSITY, 0.13f); 
	glHint(GL_FOG_HINT, GL_NICEST);
	glFogf(GL_FOG_START, 65.0f);
	glFogf(GL_FOG_END, 150.0f);
	glEnable(GL_FOG);
}

void drawCube(float size) {
    glBegin(GL_QUADS);
        glVertex3f( 1.0f, size,-1.0f);          // Top Right Of The Quad (Top)
        glVertex3f(-1.0f, size,-1.0f);          // Top Left Of The Quad (Top)
        glVertex3f(-1.0f, size, 1.0f);          // Bottom Left Of The Quad (Top)
        glVertex3f( 1.0f, size, 1.0f);          // Bottom Right Of The Quad (Top)

        glVertex3f( 1.0f, size, 1.0f);          // Top Right Of The Quad (Front)
        glVertex3f(-1.0f, size, 1.0f);          // Top Left Of The Quad (Front)
        glVertex3f(-1.0f,-1.0f, 1.0f);          // Bottom Left Of The Quad (Front)
        glVertex3f( 1.0f,-1.0f, 1.0f);          // Bottom Right Of The Quad (Front)

        glVertex3f( 1.0f,-1.0f,-1.0f);          // Bottom Left Of The Quad (Back)
        glVertex3f(-1.0f,-1.0f,-1.0f);          // Bottom Right Of The Quad (Back)
        glVertex3f(-1.0f, size,-1.0f);          // Top Right Of The Quad (Back)
        glVertex3f( 1.0f, size,-1.0f);          // Top Left Of The Quad (Back)

        glVertex3f(-1.0f, size, 1.0f);          // Top Right Of The Quad (Left)
        glVertex3f(-1.0f, size,-1.0f);          // Top Left Of The Quad (Left)
        glVertex3f(-1.0f,-1.0f,-1.0f);          // Bottom Left Of The Quad (Left)
        glVertex3f(-1.0f,-1.0f, 1.0f);          // Bottom Right Of The Quad (Left)

        glVertex3f( 1.0f, size,-1.0f);          // Top Right Of The Quad (Right)
        glVertex3f( 1.0f, size, 1.0f);          // Top Left Of The Quad (Right)
        glVertex3f( 1.0f,-1.0f, 1.0f);          // Bottom Left Of The Quad (Right)
        glVertex3f( 1.0f,-1.0f,-1.0f);          // Bottom Right Of The Quad (Right)
    glEnd();
 }

void drawGround(int size,int height,int z,int ll,int level) {
  	if (ll) { glColor3f(1.0f, 1.0f, 0.0f); } else { glColor3f(0.0f, 0.0f, 1.0f); }

	
	levels[level].setZ(z,z-size);
	glBegin(GL_QUADS);
		glVertex3f(5.0, height, z);
		glVertex3f(70.0, height, z);
		glVertex3f(70.0, height, z-size);
		glVertex3f(5.0, height, z-size);
		glVertex3f(5.0f, 0.0f, z);
		glVertex3f(70.0f, 0.0f, z);
		glVertex3f(70.0f, height, z);
		glVertex3f(5.0f, height, z);
	glEnd();
}

void doColor(int color) {
	switch (color)
	{
		case 2:
			glColor3f(0.0f, 1.0f, 0.0f);
			break;
     	case 1:
			glColor3f(1.0f, 1.0f, 1.0f);
     		break;
     	case 0:
     		glColor3f(0.5f, 0.5f, 0.9f);
     		break;
	}
}

void getMouseRate() {
	mouseF++;
	mouseTime = glutGet(GLUT_ELAPSED_TIME);
	if (mouseTime - mouseTB > (mouse_delay * 1000)) {
		mouseTB = mouseTime;
		mouseF = 0;
		mouseStop = 0;
	}
}

void getFPS() {
	frame++;
	ftime = glutGet(GLUT_ELAPSED_TIME);
	if (ftime - timebase > 1000) {
		fps = (frame*1000/(ftime-timebase));
		timebase = ftime;
		frame = 0;
	}
}

void switchView() {
	view++;
	if (view > 2) { view = 1; }
	switch(view)
	{
		case 2:
			swV2 = 1;
			break;
		case 1:
			swV1 = 1;
			break;
	}
}

void doAnimations() {
	float levelLoc;
	int totalLevelSize = 0, a, tLevel, dif = 0;
	
	for (a=clevel;a>=0;a--) { totalLevelSize += levels[a].levelSize + 1; }
	if (swV2)
	{
		//to unanimate, use these values
		//y=totalLevelSize+60;
		//x+=.5;
		//z-=55.0;
		//ly=-20;
		if (tsw < 60)
		{
			x+=.0083333333;
			z-=.91666667;
			ly-=.3333333;
			y=totalLevelSize+tsw;
			orientMe(angle);
			tsw+=1;
		} else { swV2 = 0; tsw = 0; }
	}
	if (goZ > 0)
	{
		if (view == 2) { dif = 0; } else { dif = 55; }
			
		switch (goZ)
		{
			case 3:
				levelLoc = levels[clevel].mloc;
				break;
			case 2:
				levelLoc = levels[clevel].eloc;
				break;
			case 1:
				levelLoc = levels[clevel].zloc;
				break;
		}

		if (!fOrB)
			if (z > levelLoc + dif) { fOrB = 1; } else if (z < levelLoc + dif) { fOrB = 2; } else { fOrB = 3; }
		
		switch (fOrB)
		{
			case 1:
				if (z > levelLoc + dif)
				{
					z -= 1;
					orientMe(angle);
				} else { z = levelLoc + dif; goZ = 0; fOrB = 0; orientMe(angle); }
				break;
			case 2:
				if (z < levelLoc + dif)
				{
					z += 1;
					orientMe(angle);
				} else { z = levelLoc + dif; goZ = 0; fOrB = 0; orientMe(angle); }
				break;
			case 3:
				if (view == 1)
				{
					if (z < 60)
					{
						z += 1;
						orientMe(angle);
					} else { goZ = 0; fOrB = 0; z = 60; orientMe(angle); }
				} else { goZ = 0; fOrB = 0; }
				break;
		}

	}
	if (swV1)
	{
		if (tsw < 60)
		{
			x-=.0083333333;
			z+=.91666667;
			ly+=.3333333;
			y--;
			orientMe(angle);
			tsw+=1;
		} else { swV1 = 0; tsw = 0; }
	}
	if (goDown)
	{
		if (clevel > 0) {
			tLevel = totalLevelSize - levels[clevel].levelSize;
			if (view == 2) { tLevel += 60; }
			if (y >= tLevel)
			{
				y -= .2;
				orientMe(angle);
			} else {
				goDown = 0;
				clevel--;
	            orientMe(angle);
			}
		} else {
			goDown = 0;
		}
	}
	if (goUp)
	{
		if (clevel < numLevels) {
			tLevel = totalLevelSize + levels[clevel+1].levelSize + 2;
			if (view == 2) { tLevel += 60; }
			if (y <= tLevel)
			{
				y += .2;
				orientMe(angle);
			} else {
				goUp = 0;
				clevel++;
	            orientMe(angle);
			}
		} else {
			goUp = 0;
		}
	}

	//the next couple things are for the mouse movement
	if (mouseMove)
	{
		deltaAngle=(xConv/50);
		y+=(oldMouseH/100);
		//ly+=(oldMouseH/100);
		cout << y<<":"<<ly<<":"<<oldMouseH << endl;
		moveMeFlat(-(yConv*50));
		orientMe(angle);
	}
}

void doCubeRotate()
{
	if (rotateCube > 0)
	{
		glRotatef(cr,0.0f,1.0f,0.0f);
		cr+=.05;
		if (cr > 90) { cr = 0; rotateCube = 0; }
	} else if (rotateCube < 0) {
		glRotatef(cr,0.0f,1.0f,0.0f);
		cr-=.05;
		if (cr < -90) { cr = 0; rotateCube = 0; }
	}
}

void renderIt() {
	int j=1,t,t1,t2,li=1,level=0,a,lAmnt=0,ll,rto=0,totF=totalFiles;
	char whatToDisplay[256];
	if (deltaMove)
		moveMeFlat(deltaMove);
	if (deltaAngle) {
		angle += deltaAngle;
		orientMe(angle);
	}
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glInitNames();
	t = 0;
	t1 = 0;
	t2 = 0;
	getFPS();
	getMouseRate();
	doAnimations();
	do {
		totF = totalFiles;
		if (level == clevel) { ll = 1; } else { ll = 0; }
		glColor3f(1.0f,1.0f,1.0f);
		renderString3(30,lAmnt+5,j*5,levels[level].name);
		drawGround(levels[level].numFiles,lAmnt,j*5,ll,level);
		for (t2 = 0; t2 <= level; t2++) { totF-=levels[t2].numFiles;	}
        for (a = 0; a < levels[level].numFiles; a++)
		{
	    	t++;
	        li+=2;
  			glPushMatrix();
			glTranslatef(li * 5.0,1 + lAmnt,j * 5.0);
		    if (showNames) {
				if (level == clevel || showAllNames) {
					glTranslatef(0.0f,0.0f,1.0f);
					glColor3d(0.0f,1.0f,0.0f);
					switch (displayInfo)
					{
						case 3:
							strftime(whatToDisplay,256,"%m/%d/%Y",files[level][a].m_date);
							break;
						case 2:
						    sprintf(whatToDisplay,"%o",files[level][a].permissions);
							break;
						case 1:
							sprintf (whatToDisplay, "%g", files[level][a].size);
							break;
						case 0:
							strcpy(whatToDisplay,files[level][a].name);
							break;
					}
					renderString2(0,files[level][a].b_size,whatToDisplay);
  					glTranslatef(0.0f,0.0f,-1.0f);
				}
			}
			glPushName(totF);
			doColor(files[level][a].directory);
			if (!strcmp(mouseOver,files[level][a].name) && (fileNames[*mptr].level == level)) { glColor3d(0.8f,0.8f,0.0f); }
			if (clevel == level || showAllNames) { doCubeRotate(); }
		    drawCube(files[level][a].b_size);
			glPopName();
		    glPopMatrix();
	        if (t > 5) {
	        	j--;
	            if (t1) { li = 1; t1 = 0; } else { li = 0; t1 = 1; }
	            t = 0;
				rto = 1;
    		}
			totF++;
		}
	   	lAmnt += levels[level].levelSize + 1;
		level++;
		if (!rto) { j--; }
		rto = 0;
	} while (level <= numLevels);
	glutSwapBuffers();
}

void processHits (GLuint hits, GLuint buffer[]) {
   unsigned int i, j;
   GLuint names, *ptr, minZ, *ptrNames = 0, numberOfNames = 0;

   ptr = (GLuint *) buffer;
   minZ = 0xffffffff;
   for (i = 0; i < hits; i++) {
	names = *ptr;
	ptr++;
	if (*ptr < minZ) {
	   numberOfNames = names;
	   minZ = *ptr;
	   ptrNames = ptr+2;
	}
	ptr += names+2;
   }
   ptr = ptrNames;
   mptr = ptr;
   for (j = 0; j < numberOfNames; j++,ptr++) {
	strcpy(mouseOver,files[fileNames[*ptr].level][fileNames[*ptr].filenum].name);
   }
}

void startPicking() {
	GLint viewport[4];

	glSelectBuffer(BUFSIZE,selectBuf);
	glRenderMode(GL_SELECT);

	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
	glLoadIdentity();

	glGetIntegerv(GL_VIEWPORT,viewport);
	gluPickMatrix(xmouse,viewport[3]-ymouse,5,5,viewport);
	gluPerspective(45,ratio,0.1,1000);
	glMatrixMode(GL_MODELVIEW);
	glInitNames();
}

void stopPicking() {
	int hits;

	glMatrixMode(GL_PROJECTION);
	glPopMatrix();
	glMatrixMode(GL_MODELVIEW);
	glFlush();

	hits = glRenderMode(GL_RENDER);

	if (hits != 0)
		processHits(hits,selectBuf);
}

void setOrtho() {
	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
	glLoadIdentity();
	gluOrtho2D(0, wx, 0, wy);
	glScalef(1, -1, 1);
	glTranslatef(0, -wy, 0);
	glMatrixMode(GL_MODELVIEW);
}

void resetPers() {
	glMatrixMode(GL_PROJECTION);
	glPopMatrix();
	glMatrixMode(GL_MODELVIEW);
}

void renderScene(void) {
	char fpsBuffer[50],fmodBuff[50];
	switch (fMode)
	{
		case 1:
			strcpy(fmodBuff,"copy: ");
			switch (fSelectCT)
			{
				case 0:
					strcat(fmodBuff,"select location");
					break;
				case 1:
					strcat(fmodBuff,"select file");
					break;
			}
			break;
		case 2:
			strcpy(fmodBuff,"move: ");
			switch (fSelectCT)
			{
				case 0:
					strcat(fmodBuff,"select location");
					break;
				case 1:
					strcat(fmodBuff,"select file");
					break;
			}
			break;
		case 3:
			strcpy(fmodBuff,"delete: ");
			switch (fSelectCT)
			{
				case 0:
					strcat(fmodBuff,"select file");
					break;
				case 1:
					strcat(fmodBuff,"click to confirm");
					break;
				case 2:
					strcat(fmodBuff,"click to delete");
					break;
			}
			break;
		default:
			memset(fmodBuff,' ',strlen(fmodBuff));
			break;
	}
	mptr = 0;
	sprintf (fpsBuffer, "FPS: %7.2f", fps);
	startPicking();
	renderIt();
	stopPicking();
	renderIt();
	setOrtho();
	glPushMatrix();
	glLoadIdentity();
	renderString2(1,15,mouseOver);
	renderString2(1,30,fSelect);
	renderString2(1,45,fpsBuffer);
	renderString2(1,60,fmodBuff);
	glPopMatrix();
	resetPers();
	glutSwapBuffers();
	memset(mouseOver,' ',strlen(mouseOver));
}

void pressKey(int key, int x, int y) {
	switch (key) {
		case GLUT_KEY_PAGE_UP:
			goUp = 1;
			break;
		case GLUT_KEY_PAGE_DOWN:
			goDown = 1;
			break;
		case GLUT_KEY_LEFT :
			deltaAngle = -0.01f;
			break;
		case GLUT_KEY_RIGHT :
			deltaAngle = 0.01f;
			break;
		case GLUT_KEY_UP :
			deltaMove = 1;
			break;
		case GLUT_KEY_DOWN :
			deltaMove = -1;
			break;
	}
}

void releaseKey(int key, int x, int y) {
	switch (key) {
		case GLUT_KEY_LEFT :
		case GLUT_KEY_RIGHT :
			deltaAngle = 0.0f;
			break;
		case GLUT_KEY_UP :
		case GLUT_KEY_DOWN:
			deltaMove = 0;
			break;
	}
}

void processKeys(unsigned char key, int x, int y) {
	int mod;
	switch (key)
	{
		case 9: //tab
			mod = glutGetModifiers();
			if (mod == GLUT_ACTIVE_CTRL)
			{
				displayInfo--;
				if (displayInfo < 0) { displayInfo = 3; }
				rotateCube = -1;
			} else {
				displayInfo++;
				if (displayInfo > 3) { displayInfo = 0; }
				rotateCube = 1;
			}
			break;
		case 110: //n
			showNames = !showNames;
			break;
		case 111: //o
			showAllNames = !showAllNames;
			break;
		case 118: //v
			switchView();
			break;
		case 27: //esc
			exit(0);
			break;
		case 99: //c
			fMode = 1;
			memset(fSelect,' ',strlen(fSelect));
			fSelectCT=0;
			break;
		case 109: //m
			fMode = 2;
			memset(fSelect,' ',strlen(fSelect));
			fSelectCT=0;
			break;
		case 100: //d
			fMode = 3;
			memset(fSelect,' ',strlen(fSelect));
			fSelectCT=0;
			break;
		case 102: //f
			if (fullscreen)
			{
				glutReshapeWindow(wx,wy);
				glutPositionWindow(wxp,wyp);
				fullscreen = 0;
			} else {
				glutFullScreen();
				fullscreen = 1;
			}
			break;
		case 97: //a
			goZ = 3;
			break;
		case 113: //q
			goZ = 2;
			break;
		case 122: //z
			goZ = 1;
			break;
		case 119: //w
			mouseMove = !mouseMove;
			if (!mouseMove) { 
				deltaMove = 0;
				deltaAngle = 0;
				xConv = 0;
				yConv = 0; 
			}
			break;
		case 103: //g
			if (fogOnOff)
			{
				fogOnOff = 0;
				glDisable(GL_FOG);
			} else { fogOnOff = 1; glEnable(GL_FOG); }
			break;
	}
}

void setVars() {
	view = 1;
	goDown = 0;
	goUp = 0;
	showNames = 1;
	showAllNames = 0;
	angle = 0.0f;
	deltaAngle = 0.0f;
	x = 37.5f;
	y = 0.0f;
	z = 55.0f;
	lx = 0.0f;
	ly = 0.0f;
	lz = -1.0f;
	swV1 = 0;
	swV2 = 0;
	tsw = 0;
	goZ = 0;
}

int main(int argc, char **argv) {
	glutInitDisplayMode(GLUT_DEPTH | GLUT_DOUBLE | GLUT_RGBA);
	glutInitWindowPosition(wxp,wyp);
	glutInitWindowSize(wx,wy);
	setVars();
	mainWindow = glutCreateWindow("Tilda Studios");
		glutReshapeFunc(changeSize);

		glutIgnoreKeyRepeat(1);
		glutKeyboardFunc(processKeys);
		glutSpecialFunc(pressKey);
		glutSpecialUpFunc(releaseKey);
		glutDisplayFunc(renderScene);
		glutIdleFunc(renderScene);
		setMap();
		//mouse functions
		glutMouseFunc(processMouse);
		glutMotionFunc(processMouseActiveMotion);
		glutPassiveMotionFunc(processMousePassiveMotion);
		glutEntryFunc(processMouseEntry);

		initScene();
		clevel = numLevels;

	glutMainLoop();
	return(0);
}
